# # #
# /5/main.rb
# (c) 2009 Jan Lelis <mail@janlelis.de>. MIT License.
# See: https://rbjl.janlelis.com/5-playing-with-dijkstra
# # #

# I have written this program to learn ruby... and after reading
# docs & books and hours of listining to great music like Ghosts
# from Nine Inch Nails, and some crazy stuff (do you know the band
# Cynic - they do a addictive jazz/deathmetal/disharmonic/bla mix °_°)
# ... I got the basics ;)
#
# Also... thanks to the orgas of this challenge ;)
#
# OK... lets start ;)

# important program constants
Version = 1.0

# include source files
require 'helpers.rb'
require 'config.rb'
require 'menu.rb'
require 'env.rb'
require 'algo.rb'

# 'global' function that lets start the solution algo ;)
def start(lab)
  unless lab.instance_of? Env
    raise ArgumentError, 'Please set a labyrinth file!'
  else
    # put out the lab filename again
    puts 'Labyrinth file:  ' << Config[:file].to_s unless Config[:output]==:clean
    # start timer
    timer = Time.now
    # calculate and display!
    lab.output_path Config[:algo]||:dijkstra, Config[:output]||:console
    # output timer
    puts "Time needed for calculation and output: #{(Time.now - timer)} seconds" unless Config[:output]==:clean
  end
end


# now do what the command line options tell us to do
if Config[:info]
  Menu.info # display info and exit
elsif !Config[:file]
  Menu.idle # go to menu..
elsif Config[:force_menu]
  Menu.idle Env.new Config[:file] # [forced menu! - but file is already set]
else
  start Env.new Config[:file] # ..or start the code if file was set by command line options
end
